#ifndef _ASM_ARM_OLPC_OFW_H
#define _ASM_ARM_OLPC_OFW_H

#ifdef CONFIG_OLPC

/* run an OFW command by calling into the firmware */
#define olpc_ofw(name, args, res) \
	__olpc_ofw((name), ARRAY_SIZE(args), args, ARRAY_SIZE(res), res)

extern int __olpc_ofw(const char *name, int nr_args, const void **args,
		int nr_res, void **res);

/* map OFW's page tables into kernel memory */
extern void setup_olpc_ofw_mapping(void);

/* check if OFW was detected during boot */
extern bool olpc_ofw_present(void);

extern void olpc_dt_build_devicetree(void);

#else /* !CONFIG_OLPC */
static inline void setup_olpc_ofw_mapping(void) { }
static inline void olpc_dt_build_devicetree(void) { }
#endif /* !CONFIG_OLPC */

#endif /* _ASM_ARM_OLPC_OFW_H */
